<?php

/** 
*
* mod package	Download Mod 5
* file		class_dl_portal.php v 1.5 2007/04/01 OXPUS
* copyright	(c) 2005 oxpus (Karsten Ude) <webmaster@oxpus.de> http://www.oxpus.de
* copyright mod	(c) hotschi / demolition fabi / oxpus
* license	http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/*
* class dlmod
*
* This class contains the following functions:
* --------------------------------------------
* $dl_mod->dl_cat_auth($cat_id); * Return the group permissions for the given category
* $dl_mod->get_config(); * Read the basic configuration
* $dl_mod->mini_status_file($parent, $file_id); * Returns the mini icon for one given file
* $dl_mod->full_index($parent, $auth_level, $select_id); * Returns the permissions auth_view and auth_dl or the cat ids for auth_view
* $dl_mod->dl_status($df_id); * Get the download status for the given file id
* $dl_mod->dl_client($client); * Returns the client from the current user
*/

class dlmod
{
	/*
	* init basic variables
	*/
	var $dl_auth = array();
	var $dl_config = array();
	var $dl_file = array();
	var $dl_file_icon = '';
	var $dl_index = array();
	var $path_dl_array = array();
	var $user_dl_update_time = 0;
	var $user_id = -1;
	var $user_level = 0;
	var $user_logged_in = 0;
	var $user_posts = 0;
	var $user_regdate = 0;
	var $user_traffic = 0;
	var $user_banned = 0;

	/*
	* run the class constructor
	*/
	function dlmod()
	{
		global $db, $userdata, $board_config;

		/*
		* define the current user
		*/
		$this->user_level = $userdata['user_level'];
		$this->user_id = $userdata['user_id'];
		$this->user_regdate = $userdata['user_regdate'];
		$this->user_dl_update_time = $userdata['user_dl_update_time'];
		$this->user_traffic = $userdata['user_traffic'];
		$this->user_logged_in = $userdata['session_logged_in'];
		$this->user_posts = $userdata['user_posts'];

		/*
		* read the basic configuration
		*/
		$sql = "SELECT * FROM " . DL_CONFIG_TABLE;
		if( !($result = $db->sql_query($sql)) )
		{
			message_die(CRITICAL_ERROR, "Could not query download mod configuration", "", __LINE__, __FILE__, $sql);
		}

		while ( $row = $db->sql_fetchrow($result) )
		{
			$this->dl_config[$row['config_name']] = $row['config_value'];
		}
		$db->sql_freeresult($result);

		/*
		* read the index
		*/
		$cat_fields = 'id, parent, path, cat_name, sort, bbcode_uid, auth_view, auth_dl, auth_up, auth_mod, must_approve, allow_mod_desc, statistics, stats_prune, comments, cat_traffic, cat_traffic_use, allow_thumbs, auth_cread, auth_cpost, approve_comments';

		$sql = "SELECT $cat_fields FROM " . DL_CAT_TABLE;
		if (!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not read download index data', '', __LINE__, __FILE__, $sql);
		}

		while ($row = $db->sql_fetchrow($result))
		{
			$this->dl_index[$row['id']] = $row;
		}

		$db->sql_freeresult($result);

		/*
		* get the user permissions
		*/
		$auth_perm = $auth_cat = $cat_auth_array = $group_ids = $group_perm_ids = array();

		$sql = "SELECT * FROM " . DL_AUTH_TABLE;
		if (!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not read group permissions for downloads', '', __LINE__, __FILE__, $sql);
		}

		$total_perms = $db->sql_numrows($result);

		if ($total_perms)
		{
			while ($row = $db->sql_fetchrow($result))
			{
				$cat_id = $row['cat_id'];
				$group_id = $row['group_id'];

				$auth_cat[] = $cat_id;
				$group_perm_ids[] = $group_id;

				$auth_perm[$cat_id][$group_id]['auth_view'] = $row['auth_view'];
				$auth_perm[$cat_id][$group_id]['auth_dl'] = $row['auth_dl'];
			}
			$db->sql_freeresult($result);

			if ($total_perms > 1)
			{
				$auth_cat = array_unique($auth_cat);
				sort($auth_cat);
			}

			$sql = "SELECT g.group_id FROM " . GROUPS_TABLE . " g, " . USER_GROUP_TABLE . " ug
				WHERE g.group_id IN (" . implode(', ', $group_perm_ids) . ")
					AND g.group_id = ug.group_id
					AND ug.user_id = " . $this->user_id . "
					AND g.group_single_user <> " . TRUE . "
					AND ug.user_pending <> " . TRUE;
			if (!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not fetch group ids for user', '', __LINE__, __FILE__, $sql);
			}

			while ($row = $db->sql_fetchrow($result))
			{
				$group_ids[] = $row['group_id'];
			}
			$db->sql_freeresult($result);

			for ($i = 0; $i < count($auth_cat); $i++)
			{
				$auth_view = $auth_dl = $auth_up = $auth_mod = 0;
				$cat = $auth_cat[$i];

				for ($j = 0; $j < count($group_ids); $j++)
				{
					$user_group = $group_ids[$j];

					if ($auth_perm[$cat][$user_group]['auth_view'] == TRUE)
					{
						$auth_view = TRUE;
					}
					if ($auth_perm[$cat][$user_group]['auth_dl'] == TRUE)
					{
						$auth_dl = TRUE;
					}
				}

				$cat_auth_array[$cat]['auth_view'] = $auth_view;
				$cat_auth_array[$cat]['auth_dl'] = $auth_dl;
			}
		}
		else
		{
			$db->sql_freeresult($result);
		}

		$this->dl_auth = $cat_auth_array;

		/*
		* preset all files
		*/
		$sql = "SELECT change_time, add_time, id, cat, file_name, file_size, extern, free, file_traffic, klicks FROM " . DOWNLOADS_TABLE . "
				WHERE approve = " . TRUE;
		if (!($result = $db->sql_query($sql)))
		{
			message_die(GENERAL_ERROR, 'Could not preset the download files', '', __LINE__, __FILE__, $sql);
		}

		while ($row = $db->sql_fetchrow($result))
		{
			$change_time = $row['change_time'];
			$add_time = $row['add_time'];

			$count_new = ($change_time ==  $add_time && ((time() - $add_time)) / 86400 <= $this->dl_config['dl_new_time'] && $this->dl_config['dl_new_time'] > 0) ? 1 : 0;
			$count_edit = ($change_time !=  $add_time && ((time() - $change_time) / 86400) <= $this->dl_config['dl_edit_time'] && $this->dl_config['dl_edit_time'] > 0) ? 1 : 0;

			$this->dl_file_icon['new'][$row['cat']][$row['id']] = $count_new;
			$this->dl_file_icon['new_sum'][$row['cat']] += $count_new;
			$this->dl_file_icon['edit'][$row['cat']][$row['id']] = $count_edit;
			$this->dl_file_icon['edit_sum'][$row['cat']] += $count_edit;
			$this->dl_file[$row['id']] = $row;
		}
		$db->sql_freeresult($result);

		/*
		* get ban status for current user
		*/
		$sql_guests = (!$this_>user_logged_in) ? " OR guests = 1 " : '';
		$sql = "SELECT ban_id FROM " . DL_BANLIST_TABLE . "
			WHERE user_id = " . $this->user_id . "
				OR user_ip = '" . $this->user_ip . "'
				OR user_agent LIKE '%" . $this->dl_client() . "%'
				OR username = '" . str_replace("'", "%", $this->username) . "'
				$sql_guests";
		if (!($result = $db->sql_query($sql)))
		{
			message_die(GENERAL_ERROR, 'Could not fetch banlist', '', __LINE__, __FILE__, $sql);
		}
		$total_ban_ids = $db->sql_numrows($result);
		$db->sql_freeresult($result);

		if ($total_ban_ids)
		{
			$this->user_banned = true;
		}

		return;
	}

	function dl_cat_auth($cat_id)
	{
		$cat_perm = array();

		$cat_perm['auth_view'] = intval($this->dl_auth[$cat_id]['auth_view']);
		$cat_perm['auth_dl'] = intval($this->dl_auth[$cat_id]['auth_dl']);

		return $cat_perm;
	}

	function get_config()
	{
		return $this->dl_config;
	}

	function mini_status_file($parent, $file_id)
	{
		global $images;

		if ($this->dl_file_icon['new'][$parent][$file_id])
		{
			$mini_icon_img = '<img src="'.$images['Dl_new'].'" alt="" title="" border="0" />&nbsp;';
		}
		else if ($this->dl_file_icon['edit'][$parent][$file_id])
		{
			$mini_icon_img = '<img src="'.$images['Dl_edit'].'" alt="" title="" border="0" />&nbsp;';
		}
		else
		{
			$mini_icon_img = '';
		}

		return $mini_icon_img;
	}

	function full_index($parent = 0, $auth_level = 0, $select_id = 0)
	{
		foreach($this->dl_index as $cat_id => $value)
		{
			if ($cat_id == $select_id)
			{
				return $this->dl_index[$cat_id]['auth_dl'];
			}
			else if ($this->dl_index[$cat_id]['auth_view'] || $this->dl_auth[$cat_id]['auth_view'] || $this->user_level == ADMIN)
			{
				if ($auth_level)
				{
					$access_ids[] = $cat_id;
				}
				else
				{
					$tree_dl[$cat_id]['auth_view'] = $this->dl_index[$cat_id]['auth_view'];
					$tree_dl[$cat_id]['auth_dl'] = $this->dl_index[$cat_id]['auth_dl'];
				}
			}
		}

		return ($auth_level) ? $access_ids : $tree_dl;
	}

	function dl_status($df_id)
	{
		global $images, $lang, $phpEx;

		$lang['Dl_red_explain_alt'] = sprintf($lang['Dl_red_explain_alt'], $this->dl_config['dl_posts']);

		$cat_id = $this->dl_file[$df_id]['cat'];
		$cat_auth = array();
		$cat_auth = $this->dl_cat_auth($cat_id);
		$index = array();
		$index = $this->full_index(0, 0, $cat_id);
		$status = '';
		$file_name = '';
		$auth_dl = 0;

		$file_name = '<a href="'.append_sid("downloads.$phpEx?view=detail&amp;df_id=$df_id").'">'.$this->dl_file[$df_id]['file_name'].'</a>';

		if ($this->user_banned)
		{
			$status = '<a href="'.append_sid("downloads.$phpEx?view=detail&amp;df_id=$df_id").'"><img src="' . $images['Dl_acp_banlist'] . '" border="0" alt="' . $lang['Dl_banned'] . '" title="' . $lang['Dl_banned'] . '" /></a>';
			$auth_dl = 0;
			return array('status' => $status, 'file_name' => $file_name, 'auth_dl' => $auth_dl);
		}

		if ($this->user_logged_in && intval($this->user_traffic) > $this->dl_file[$df_id]['file_size'] && !$this->dl_file[$df_id]['extern'])
		{
			$status = '<a href="'.append_sid("downloads.$phpEx?view=detail&amp;df_id=$df_id").'"><img src="' . $images['Dl_yellow'] . '" border="0" alt="' . $lang['Dl_yellow_explain'] . '" title="' . $lang['Dl_yellow_explain'] . '" /></a>';
			$auth_dl = TRUE;
		}
		else
		{
			$status = '<a href="'.append_sid("downloads.$phpEx?view=detail&amp;df_id=$df_id").'"><img src="' . $images['Dl_red'] . '" alt="' . $lang['Dl_red_explain_alt'] . '" title="' . $lang['Dl_red_explain_alt'] . '" /></a>';
			$auth_dl = 0;
		}

		if ($this->user_posts < $this->dl_config['dl_posts'] && !$this->dl_file[$df_id]['extern'] && !$this->dl_file[$df_id]['free'])
		{
			$status = '<a href="'.append_sid("downloads.$phpEx?view=detail&amp;df_id=$df_id").'"><img src="' . $images['Dl_red'] . '" alt="' . $lang['Dl_red_explain_alt'] . '" title="' . $lang['Dl_red_explain_alt'] . '" /></a>';
			$auth_dl = 0;
		}

		if ($this->dl_file[$df_id]['free'])
		{
			$status = '<a href="'.append_sid("downloads.$phpEx?view=detail&amp;df_id=$df_id").'"><img src="' . $images['Dl_green'] . '" border="0" alt="' . $lang['Dl_green_explain'] . '" title="' . $lang['Dl_green_explain'] . '" /></a>';
			$auth_dl = TRUE;
		}

		if ($this->dl_file[$df_id]['free'] == 2 && $this->user_logged_in)
		{
			$status = '<a href="'.append_sid("downloads.$phpEx?view=detail&amp;df_id=$df_id").'"><img src="' . $images['Dl_white'] . '" border="0" alt="' . $lang['Dl_white_explain'] . '" title="' . $lang['Dl_white_explain'] . '" /></a>';
			$auth_dl = TRUE;
		}

		if (!$cat_auth['auth_dl'] && !$index[$cat_id]['auth_dl'] && $this->user_level != ADMIN)
		{
			$status = '<a href="'.append_sid("downloads.$phpEx?view=detail&amp;df_id=$df_id").'"><img src="' . $images['Dl_red'] . '" alt="' . $lang['Dl_red_explain_perm'] . '" title="' . $lang['Dl_red_explain_perm'] . '" /></a>';
			$auth_dl = 0;
		}

		if ($this->dl_file[$df_id]['file_traffic'] && $this->dl_file[$df_id]['klicks'] * $this->dl_file[$df_id]['file_size'] >= $this->dl_file[$df_id]['file_traffic'])
		{
			$status = '<a href="'.append_sid("downloads.$phpEx?view=detail&amp;df_id=$df_id").'"><img src="' . $images['Dl_blue'] . '" alt="' . $lang['Dl_blue_explain_file'] . '" title="' . $lang['Dl_blue_explain_file'] . '" /></a>';
			$auth_dl = 0;
		}

		if ($this->dl_config['overall_traffic'] - $this->dl_config['remain_traffic'] <= 0)
		{
			$status = '<a href="'.append_sid("downloads.$phpEx?view=detail&amp;df_id=$df_id").'"><img src="' . $images['Dl_blue'] . '" alt="' . $lang['Dl_blue_explain'] . '" title="' . $lang['Dl_blue_explain'] . '" /></a>';
			$auth_dl = 0;
		}

		if ($this->dl_file[$df_id]['extern'])
		{
			$status = '<a href="'.append_sid("downloads.$phpEx?view=detail&amp;df_id=$df_id").'" target="_'.$this->dl_file[$id]['file_name'].'"><img src="' . $images['Dl_grey'] . '" border="0" alt="' . $lang['Dl_grey_explain'] . '" title="' . $lang['Dl_grey_explain'] . '" /></a>';
			$file_name = '<a href="'.append_sid("downloads.$phpEx?view=detail&amp;df_id=$df_id").'" target="_blank">'.$lang['Dl_extern'].'</a>';
			$auth_dl = TRUE;
		}

		return array('status' => $status, 'file_name' => $file_name, 'auth_dl' => $auth_dl);
	}

	function dl_client()
	{
		$client = $this->user_client;

		if (strstr($client, "gecko"))
		{
			if (strstr($client, "safari"))
			{
				$browser_name = "Safari";
			}
			else if (strstr($client, "camino"))
			{
				$browser_name = "Camino";
			}
			else if (strstr($client, "epiphany"))
			{
				$browser_name = "Epiphany";
			}
			else if (strstr($client, "firefo"))
			{
				$browser_name = "Firefox";
			}
			else if (strstr($client, "konqueror"))
			{
				$browser_name = "Konqueror";
			}
			else if (strstr($client, "netscape"))
			{
				$browser_name = "Netscape";
			}
			else if (strstr($client, "seamonk"))
			{
				$browser_name = "SeaMonkey";
			}
			else if (strstr($client, "cback"))
			{
				$browser_name = "CBACK";
			}
			else
			{
				$browser_name = "Mozilla";
			}
		}
		else if (strstr($client, "opera"))
		{
			$browser_name = "Opera";
		}
		else if (strstr($client, "abolimba"))
		{
			$browser_name = "Abolimba";
		}
		else if (strstr($client, "msie"))
		{
			if (strstr($client, "maxthon"))
			{
				$browser_name = "Maxthon";
			}
			else
			{
				$browser_name = "Internet Explorer";
			}
		}
		else if (strstr($client,"voyager"))
		{
			$browser_name = "Voyager";        
		}
		else if (strstr($client,"lynx"))
		{
			$browser_name = "Lynx";
		}
		else
		{
			$browser_name = "n/a";
		}

		return $browser_name;
	}
}

?>