<?php

/** 
*
* mod package	Download Mod 5
* file		class_hacklist.php v 1.0 2006/03/22 OXPUS
* copyright	(c) 2005 oxpus (Karsten Ude) <webmaster@oxpus.de> http://www.oxpus.de
* copyright mod	(c) hotschi / demolition fabi / oxpus
* license	http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/*
* class hacklist
*
* This class contains the following functions:
* --------------------------------------------
* $dl_mod->hacks_index($parent); * Create the complete hacklist index
* $dl_mod->all_files($cat_id, $sql_sort_by, $sql_order); * Return the hacklist data for the given category
*/

class hacklist
{
	/*
	* init basic variables
	*/
	var $dl_auth = array();
	var $dl_config = array();

	/*
	* run the class constructor
	*/
	function hacklist()
	{
		global $db, $userdata;

		/*
		* get hacklist on/off status
		*/
		$sql = "SELECT config_value FROM " . DL_CONFIG_TABLE . "
			WHERE config_name = 'use_hacklist'";
		if( !($result = $db->sql_query($sql)) )
		{
			message_die(CRITICAL_ERROR, "Could not query download mod configuration", "", __LINE__, __FILE__, $sql);
		}

		while ( $row = $db->sql_fetchrow($result) )
		{
			$this->dl_config['use_hacklist'] = $row['config_value'];
		}
		$db->sql_freeresult($result);

		/*
		* get the user permissions
		*/
		$auth_perm = $auth_cat = $cat_auth_array = $group_ids = $group_perm_ids = array();

		$sql = "SELECT * FROM " . DL_AUTH_TABLE;
		if (!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not read group permissions for downloads', '', __LINE__, __FILE__, $sql);
		}

		$total_perms = $db->sql_numrows($result);

		if ($total_perms)
		{
			while ($row = $db->sql_fetchrow($result))
			{
				$cat_id = $row['cat_id'];
				$group_id = $row['group_id'];

				$auth_cat[] = $cat_id;
				$group_perm_ids[] = $group_id;

				$auth_perm[$cat_id][$group_id]['auth_view'] = $row['auth_view'];
			}
			$db->sql_freeresult($result);

			if ($total_perms > 1)
			{
				$auth_cat = array_unique($auth_cat);
				sort($auth_cat);
			}

			$sql = "SELECT g.group_id FROM " . GROUPS_TABLE . " g, " . USER_GROUP_TABLE . " ug
				WHERE g.group_id IN (" . implode(', ', $group_perm_ids) . ")
					AND g.group_id = ug.group_id
					AND ug.user_id = " . $userdata['user_id'] . "
					AND g.group_single_user <> " . TRUE . "
					AND ug.user_pending <> " . TRUE;
			if (!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not fetch group ids for user', '', __LINE__, __FILE__, $sql);
			}

			while ($row = $db->sql_fetchrow($result))
			{
				$group_ids[] = $row['group_id'];
			}
			$db->sql_freeresult($result);

			for ($i = 0; $i < count($auth_cat); $i++)
			{
				$auth_view = 0;
				$cat = $auth_cat[$i];

				for ($j = 0; $j < count($group_ids); $j++)
				{
					$user_group = $group_ids[$j];

					if ($auth_perm[$cat][$user_group]['auth_view'] == TRUE)
					{
						$auth_view = TRUE;
					}
				}

				$cat_auth_array[$cat]['auth_view'] = $auth_view;
			}
		}
		else
		{
			$db->sql_freeresult($result);
		}

		$this->dl_auth = $cat_auth_array;

		return;
	}

	function hacklist_status()
	{
		return $this->dl_config['use_hacklist'];
	}

	function hacks_index()
	{
		global $db, $userdata;

		$tree_dl = array();

		$sql = "SELECT id, cat_name, auth_view FROM " . DL_CAT_TABLE . "
			ORDER BY parent, sort";
		if (!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not read download index data', '', __LINE__, __FILE__, $sql);
		}

		while ($row = $db->sql_fetchrow($result))
		{
			$cat_id = $row['id'];

			if ($row['auth_view'] || $this->dl_auth[$cat_id]['auth_view'] || $userdata['user_level'] == ADMIN)
			{
				$tree_dl[$cat_id] = $row['cat_name'];
			}
		}

		return $tree_dl;
	}

	function all_files($sql_sort_by, $sql_order, $limit = '')
	{
		global $db;

		$dl_files = array();

		$sql = "SELECT * FROM " . DOWNLOADS_TABLE . "
			WHERE approve = " . TRUE . "
				AND hacklist = 1
			ORDER BY $sql_sort_by $sql_order
			$limit";
		if (!($result = $db->sql_query($sql)))
		{
			message_die(GENERAL_ERROR, 'Could not preset the download files', '', __LINE__, __FILE__, $sql);
		}

		while ($row = $db->sql_fetchrow($result))
		{
			$dl_files[] = $row;
		}
		$db->sql_freeresult($result);

		return $dl_files;
	}
}

?>